<?php

/*------------------------------------------------------------------------
# GRA4 
# ------------------------------------------------------------------------
# author    gra4.com
# copyright Copyright (C) 2012 gra4.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://gra4.com
# Technical Support:  http://gra4.com/groups/profile/98/gra4-webmasters-wordpress
-------------------------------------------------------------------------*/

//interface between gra4 and local client system
if (!defined('IN_GRA4'))
{
	exit;
}

//In case callback is specified in the gra4_config (like http://server.com/joomla/components/com_gra4/gra4.php) , 
// this file will be called not from Joomla framework, but directly.
// To call Joomla methods, we have to initialize the framewirk
/*
if( (isset($_SERVER['HTTP_GRA4_CLIENT_SIGNATURE'])) &&  (!defined('_JEXEC')) ) //we are called not from framework, but from the callback URL
{
	define( '_JEXEC', 1 );
	chdir('../../'); //back to joomla dir - or framefork gonna fail	
	define('JPATH_BASE', getcwd());
	define('DS', DIRECTORY_SEPARATOR);
	require_once ( JPATH_BASE .DS.'includes'.DS.'defines.php' );
	require_once ( JPATH_BASE .DS.'includes'.DS.'framework.php' );
	$mainframe =& JFactory::getApplication('site');	
}
*/
//IMPORTANT - if  GRA4IsAuthenticatedUser() function is incorrect, 
//the anonimous users will be able to pretend they are authenticated by your site
function GRA4IsAuthenticatedUser()
{
	global $user_ID;
	return($user_ID > 0);
}

function GRA4GetLocalUserName()
{
	global $user_ID;
	$oUser = get_userdata($user_ID);
	return($oUser->user_nicename);
}

function GRA4GetLocalUserId()
{
	global $user_ID;
	return($user_ID);
}


function GRA4GetLocalSiteName()
{
	return(get_bloginfo('name'));
}

function GRA4IsLocalAdmin()
{
	global $user_ID;
	if($user_ID == 0)
	{
		return false; //noone logged in
	}
	$oUser = get_userdata($user_ID);
	return($oUser->caps['administrator'] == 1);
}


function GRA4GetLocalClientVersion()
{
	return('wordpress.0.0.1.3');
//PLEASE NOTE: This is version of GRA4 interface, not the version of this module!
//If you building new GRA4 clien for some popular engine, use name_of_engine.0.1.0.1
//For support contact GRA4 at http://gra4.com/relatedgroups/owner/94

}

//forward message to the user - so they can be notified without visiting GRA4
function GRA4ForwardMessageToLocalUser($strUserId,$strSubject,$strBody)
{
	if(get_magic_quotes_gpc() == 1)	
	{
		$strSubject = stripslashes($strSubject);
		$strBody = stripslashes($strBody);
	}
	$strSubject = '[GRA4] '.html_entity_decode($strSubject);
	$strBody = html_entity_decode($strBody);

	$oUser = get_userdata(intval($strUserId));
	$recipient = $oUser->user_email;
	$bRes = mail($recipient,$strSubject,$strBody);
} //EOF GRA4ForwardMessageToLocalUser()

//NOTE - GRA4 does not ask (and never will ask) for password of the local user.
//GRA4 just wants to confirm that the password (the user willingly provided) is valid.
function GRA4ConfirmLocalAuth($strUserId, $strPassword)
{
	$oUser = get_userdata($strUserId);
	$userpassword = $user->data->user_pass;
	$userlogin = $user->data->user_login;


	$user = wp_authenticate($userlogin, $userpassword);
	return(is_wp_error($user));
}//EOF GRA4ConfirmLocalAuth

//This function is pretty much for the development of GRA4 modules for new platforms
//Insert it somewhere where the GRA4 functionality must be alreary present, and see if it is actually present =)
function GRA4TestLocalFunctions()
{
//TEST OF LOCAL FUNCTIONS
	echo('<br>function GRA4GetLocalClientVersion()<br>');
	echo('Local Client Version:' . GRA4GetLocalClientVersion());

	echo('<hr>function GRA4IsAuthenticatedUser()<br>');
	if(GRA4IsAuthenticatedUser()) echo('Is Authenticated User ');
	else echo('Is NOT Authenticated User ');


	echo('<hr>function GRA4GetLocalUserName()<br>');
	echo('Local User Name:' . GRA4GetLocalUserName());

	echo('<hr>function GRA4GetLocalUserId()<br>');
	echo('Local User Id:' . GRA4GetLocalUserId());

	echo('<hr>function GRA4GetLocalSiteName()<br>');
	echo('Local Site Name:' . GRA4GetLocalSiteName());


	echo('<hr>function GRA4IsLocalAdmin()<br>');
	if(GRA4IsLocalAdmin()) echo('Is Local Admin');
	else echo('Is NOT In Local Admin');


	echo('<hr>function GRA4ForwardMessageToLocalUser ($strUserId,$strSubject,$strBody)<br>');
	if(GRA4IsAuthenticatedUser())
	{
		GRA4ForwardMessageToLocalUser(GRA4IsAuthenticatedUser(),'Test Message from GRA4TestLocalFunctions',"Hello\nLine One\nLine Two");
		echo('Message is on the way - check if you received it.');
	}
	else
	{
		echo('Unable to test - local user is not logged in.');
	}


	echo('<hr>function GRA4ConfirmLocalAuth($strUserId, $strPassword)<br>');
	$strMyPassword = 'ChangeMeToPassword'; //Don't forget to erase after test
	if(GRA4IsAuthenticatedUser())
	{
		echo('Auth for User Id:' . GRA4IsAuthenticatedUser() . ' and password:' . $strMyPassword);

		if(GRA4ConfirmLocalAuth(GRA4IsAuthenticatedUser(), $strMyPassword)) echo(' is confirmed.');
		else echo(' is NOT confirmed.');
	}
	else
	{
		echo('Unable to test - local user is not logged in.');
	}
}//EOF GRA4TestLocalFunctions

//NO EMPTY LINES AFTER '>', or Location headers will fail !
?>